VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   6060
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   3000
   Icon            =   "Anag.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   404
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   200
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdFind 
      Caption         =   "Find"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   315
      Left            =   240
      TabIndex        =   3
      Top             =   1200
      Width           =   1035
   End
   Begin VB.PictureBox Picture1 
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000009&
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   3795
      Left            =   240
      ScaleHeight     =   249
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   161
      TabIndex        =   2
      Top             =   1620
      Width           =   2475
   End
   Begin VB.Frame Frame1 
      Caption         =   "        Input 2 to 9 letters    "
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   915
      Left            =   180
      TabIndex        =   0
      Top             =   120
      Width           =   2595
      Begin VB.TextBox Text1 
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   12
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   420
         Left            =   270
         MaxLength       =   9
         TabIndex        =   1
         Text            =   "Text1"
         Top             =   285
         Width           =   1965
      End
   End
   Begin VB.Label Label2 
      Caption         =   "Perms needed"
      Height          =   375
      Left            =   1500
      TabIndex        =   5
      Top             =   1140
      Width           =   1215
   End
   Begin VB.Label Label1 
      Height          =   495
      Left            =   240
      TabIndex        =   4
      Top             =   5520
      Width           =   2475
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Anagrams  by Robert Rayment

'Anagrams of 2 to 9 ketters
'Using UCACD word list see UKACD.txt

'From UKACD.txt the following were derived:-
'ACD.txt ordered in groups according to first
'3 letters   aaa...,aab... etc to zzz...
'   & each group arranged alphbetically (NB + xxx)
'ACD3ADDR.txt pointers to start of each 3 letter group

'Dijkstra's algorithm used for getting the
'next lexigraphical permutation

'Files needed in same folder
'FileIn$ = "ACD.txt"          size 871611B
'AddFile$ = "ACD3ADDR.txt"    size 68253B
'NB these could be combined into one file.

Option Base 1
DefInt A-T
DefSng U-Z

Dim FinSize&   'Size of "ACD.txt" 871611 bytes
Dim A3A&()     'Pointers to 3 letter starts in ACD.txt

Dim wordin() As Byte  'To hold individual ascii characters of the permed word
Dim ValidWord$()      'Stores valid words to avoid duplicates with repeated letters
Dim NValidWords       'Number of valid words

Dim a()     'To hold permed numbers
Dim atemp() 'To temp hold permed numbers

Dim wpntr&  'Pointer to start of word
Dim N       'Number of characters in the inputted word
Dim num1, num2, num3  'For tracking perm changes
Dim NFact&, NFact3&   'Factorials
Dim WordString$ 'To hold the whole of "ACDLEN.txt" 871611 bytes!


Private Sub Form_Load()
Caption = "Anagrams by RR"
Text1.Text = ""
Form1.Top = 1000
Form1.Left = 1000
Show

On Error GoTo fileerr1

FileIn$ = App.Path & "\ACD.txt"

'Test if file exists
'For input else zero length binary file made
Open FileIn$ For Input As #1
Close #1

'Put whole of ACDLEN (871611B) into WordString$
Open FileIn$ For Binary As #1
FinSize& = LOF(1)
WordString$ = Space$(FinSize&)
Get #1, , WordString$
Close

ReDim A3A&(1 To 26, 1 To 26, 1 To 26)

On Error GoTo fileerr2

AddFile$ = App.Path & "\ACD3ADDR.txt"

Open AddFile$ For Input As #1
For i = 1 To 26
For j = 1 To 26
For k = 1 To 26
    Input #1, A3A&(i, j, k)
Next k
Next j
Next i
Close
Exit Sub
'============
fileerr1:
m$ = "ACD.txt missing or error"
MsgBox (m$)
Unload Form1
End
fileerr2:
m$ = "ACD3ADDR.txt missing or error"
MsgBox (m$)
Unload Form1
End
End Sub

Private Sub cmdFind_Click()
'INPUTTED WORD:  MUST BE >=2 & <=9 letters

t! = Timer

anaword$ = LCase$(Text1.Text)
N = Len(anaword$)

If N < 2 Or lena > N Then
   Text1.SetFocus
   Beep
   Exit Sub
End If

NFact& = 1
'Find N factorial = number of permutations
'NFact3& number of perms between 2 letter sets
For m = 2 To N
    NFact& = NFact& * m
    If m = N - 3 Then NFact3& = NFact&
Next m

Label2.Caption = "Perms needed" & vbCrLf & Str$(NFact&)
Label2.Refresh

Picture1.Cls
Pic$ = "Letters = " & anaword$ & " (" & Trim$(Str$(N)) & ")"
Picture1.Print Pic$
Picture1.Print "Words are:-"
Picture1.Print
Picture1.Refresh

Label1.Caption = "Working"
Label1.Refresh

'Deal with 2 letters separately
If N = 2 Then
   wpntr& = 52
   endpt& = 374
   lensub& = endpt& - wpntr& + 1
   word$ = anaword$
   tword$ = Chr$(13) + word$ + Chr$(13)
   p1& = InStr(1, Mid$(WordString$, wpntr& - 1, lensub&), tword$)
   If p1& <> 0 Then Picture1.Print word$
   
   If Right$(anaword$, 1) <> Left$(anaword$, 1) Then
      word$ = Right$(anaword$, 1) + Left$(anaword$, 1)
      tword$ = Chr$(13) + word$ + Chr$(13)
      p2& = InStr(1, Mid$(WordString$, wpntr& - 1, lensub&), tword$)
      If p2& <> 0 Then Picture1.Print word$
   End If
   
   If p1& = 0 And p2& = 0 Then Picture1.Print "NONE"
   
   Itime = Int(Timer - t!)
   If Itime < 0 Then Itime = 0
   Label1.Caption = "Took " & Itime & " sec && used " & NFact& & " perms"
   Text1.SetFocus
   Exit Sub
End If

NValidWords = 0
ReDim ValidWord$(1)
ValidWord$(1) = " "  ' anaword$

ReDim a(1 To N)
ReDim atemp(1 To N)

'Init permutations number array
For m = 1 To N
    a(m) = m
Next m

'Put separate letters into wordin().
'Permed numbers a() will then be subscripts
'to wordin() so that a new permed word can
'be assembled.  Also check for non-letters.

ReDim wordin(N)
For m = 1 To N
   wordin(m) = Asc(Mid$(anaword$, m, 1))
   If wordin(m) < 97 Or wordin(m) > 122 Then
      Text1.SetFocus
      Beep
      Exit Sub
   End If
Next m

num1 = a(1)
num2 = a(2)
num3 = a(3)
mm& = 1
GoTo ff1 'Skip 1st perm & test if input word is valid

Do
    
    GetNextPerm
ff1:
    mmbump = 1
    FindValidWords word$

    If N > 5 Then
    If (a(1) <> num1 Or a(2) <> num2 Or a(3) <> num3) And wpntr& = 0 Then
    
    'REDUCE NUMBER OF PERMS NEEDED
    
    'word$ ="" and
    '1st 3 numbers (ie ss to letters) have changed & these
    '3 start letters do not exist in the word list.  Therefore
    'can jump (N-3)!-1 ie NFact3&-1 in mm& which takes perm to
    'end of this 3 letter set & the next perm will be the start
    'of the next 3 letter set, BUT must 1st reverse
    'the last N-3 a(4) to a(N) order.  Then set num1, num2 & num3
    'to new a(1), a(2) & a(3) of next set.
    'The largest mmbump is (9-3)! - 1 = 720-1 = 719
      
      'Set num1 num2 num3 to next 3 letter set
      num1 = a(1)
      num2 = a(2)
      num3 = a(3)
      
      If a(3) < N Then
         num3 = a(3) + 1 'num1 num2 stay
      Else
         num3 = 1
         If a(2) < N Then
            num2 = a(2) + 1   'num1 stays
         Else
            num2 = 1
            If a(1) < N Then
               num1 = a(1) + 1
            Else
            '?
            Stop
            End If
         End If
      End If
      
      'Reverse numbers 4 to N
      For m = 4 To N
         atemp(m) = a(N - (m - 4))
      Next m
    
      For m = 4 To N
         a(m) = atemp(m)
      Next m
      
      'Change mmbump so that mm& goes to end of this 3 letter set
      mmbump = NFact3& - 1
      '-1 so that next perm will start @ next 3 letter set.
      'Reduce total number of perms by mmbump
      NFact& = NFact& - mmbump
    End If
    End If
    
    If word$ <> "" Then 'Have a valid word
       'Is it the first word?
       If NValidWords = 0 Then
           NValidWords = NValidWords + 1
           ReDim Preserve ValidWord$(NValidWords)
           ValidWord$(NValidWords) = word$
           Picture1.Print word$
           Picture1.Refresh
       Else  'Not the first valid word
          'Avoid repeat words (ie from repeated letters)
           For iw = 1 To NValidWords
               If word$ = ValidWord$(iw) Then Exit For
           Next iw
           If iw = NValidWords + 1 Then 'Not a repeat
              NValidWords = NValidWords + 1
              ReDim Preserve ValidWord$(NValidWords)
              ValidWord$(NValidWords) = word$
              Picture1.Print word$
              Picture1.Refresh
           End If
       End If
    
    End If
mm& = mm& + mmbump
Loop While mm& <= NFact& - 1

If NValidWords = 0 Then Picture1.Print "NONE"


Close #1
Itime = Int(Timer - t!)
If Itime < 0 Then Itime = 0
Label1.Caption = "Took " & Itime & " sec && used " & NFact& & " perms"
Text1.SetFocus

End Sub

Private Sub FindValidWords(word$)

'NEEDS
'Dim A3A&(n1,n2,n3)  'Addr of Start of 3 letter group
'Dim WordString$
'Dim wordin() As Byte
'Dim a()  'To hold permed numbers
'Dim N    'Number of characters in word

word$ = ""

'1st letter of new permed word
'let1$ = Chr$(wordin(a(1)))
'2nd letter of new permed word
'let2$ = Chr$(wordin(a(2)))
'3rd letter of new permed word
'let3$ = Chr$(wordin(a(3)))

'Set search to start of letter group
NA1 = wordin(a(1)) - 96
NA2 = wordin(a(2)) - 96
NA3 = wordin(a(3)) - 96

wpntr& = A3A&(NA1, NA2, NA3)

'If no words start with these 3 letters then
'return with wpntr&=0 and word$=""
If wpntr& = 0 Then Exit Sub

'Find end point at next 3 letter start address
'to limit length of string being searched,
'saves a large amount of time.

endpt& = 0

NA3 = NA3 + 1
If NA3 > 26 Then
   NA3 = 1: NA2 = NA2 + 1
   If NA2 > 26 Then
      NA2 = 1: NA1 = NA1 + 1
      If NA1 > 26 Then
         endpt& = FinSize&
      End If
   End If
End If

If endpt& = 0 Then
   For i = NA1 To 26
   For j = NA2 To 26
   For k = NA3 To 26
      endpt& = A3A&(i, j, k)
      If endpt& <> 0 Then Exit For
   Next k
   If endpt& <> 0 Then Exit For
   Next j
   If endpt& <> 0 Then Exit For
   Next i
End If
If endpt& = 0 Then
   endpt& = FinSize&
End If

lensub& = endpt& - wpntr& + 1

'If lensub& < 2 Then Exit Sub   'error word$=""

'Assemble new permed word
For nn = 1 To N
    word$ = word$ + Chr$(wordin(a(nn)))
Next nn

If N = 3 And word$ = "xxx" Then word$ = "": Exit Sub

'Place &HD before and after word$ to limit search
'to the right length, otherwise parts of words matching
'word$ would be found
tword$ = Chr$(13) + word$ + Chr$(13)

p& = InStr(1, Mid$(WordString$, wpntr& - 1, lensub&), tword$)


If p& = 0 Then word$ = ""

End Sub

Private Sub GetNextPerm()
'Dijkstra's (pronounced Deekstra) algorithm for
'getting the next lexigraphical permutation

'Dim a()  'To hold permed numbers (initially 1 to N)
'Dim N    'Number of characters in word

i = N - 1

While a(i) >= a(i + 1)
    i = i - 1
Wend

j = N

While a(j) <= a(i)
    j = j - 1
Wend

k = a(i)
a(i) = a(j)
a(j) = k
i = i + 1
j = N

While i < j
    k = a(i)
    a(i) = a(j)
    a(j) = k
    i = i + 1
    j = j - 1
Wend
End Sub

Private Sub Text1_KeyPress(KeyAscii As Integer)
If KeyAscii = 13 Then  'CR
   KeyAscii = 0  'Stops Beep
   cmdFind.SetFocus
   cmdFind_Click
End If
End Sub
